<?php
/*
 This file creates new lecture(as well as copy lecture);
Input: 
t_lecturename - lecture name for new lecture;
t_coursenumber - course number;
t_userid - user id;
t_lectureid - lecture ID. If this Id is specified, the new lecture would be created as a copy of provided lecture
*/

include 'logging.php';
include 'database.php';

if(!isset($_POST["t_lecturename"]))
{
	echo '{"error":"Provide lecture name"}';
	return;
}

if(!isset($_POST["t_coursenumber"]) )
{
	echo '{"error":"Provide course number"}';
	return;
}

if (!isset($_POST["t_userid"]))
{
	echo '{"error":"User is not logged in"}';
	return;
}

mysqli_autocommit($gv_link, FALSE);
$gv_lecturename = cleanparam($_POST["t_lecturename"]);
$gv_coursenumber = cleanparam($_POST["t_coursenumber"]);
$gv_userid = cleanparam($_POST["t_userid"]);

$gv_queryAddLesson = "INSERT INTO vullo_lectures (`lecturename`,`coursenumber`) VALUES ('".$gv_lecturename."','".$gv_coursenumber."')";
if ($gv_result = mysqli_query($gv_link, $gv_queryAddLesson)) 
{ 
	$gv_inserted = mysqli_insert_id($gv_link);
	$gv_queryRegisterToUser = "INSERT INTO lecture_user_xref (`lecture_id`, `user_id`) VALUES ('".$gv_inserted."', '".$gv_userid."')";
       mysqli_query($gv_link,$gv_queryRegisterToUser);
	mysqli_commit($gv_link);
     
	/* if t_lectureid is provided, we need to copy data from existing lecture*/
       if (isset($_POST["t_lectureid"]))
	{
		$gv_lectureId = cleanparam($_POST["t_lectureid"]);
		/*copy video and poster*/
		copyVideo("../videotracks/".$gv_lectureId."/", "../videotracks/".$gv_inserted."/");
		copyPoster($gv_lectureId,$gv_link,$gv_inserted);
		copyVideoRecords($gv_lectureId,$gv_link,$gv_inserted);	
              copySlides($gv_lectureId,$gv_link,$gv_inserted);
	}
	mysqli_commit($gv_link);	
	echo $gv_inserted;
}
else{
		printf("Error: %s\n", mysqli_error($link)); 
}

include('databaseclose.php');

function copyVideo($source,$target) { 
if (file_exists($source))
{
	if ( is_dir( $source ) ) {
		@mkdir( $target );
		$d = dir( $source );
		while ( FALSE !== ( $entry = $d->read() ) ) {
			if ( $entry == '.' || $entry == '..' ) {
				continue;
			}
			$Entry = $source . '/' . $entry; 
			if (is_dir( $Entry ) ) {
				continue;
			}
			copy( $Entry, $target . '/' . $entry );
		}
 
		$d->close();
	}else {
		copy( $source, $target );
	}
}
}

function copyPoster($pv_lectureId, $pv_link, $pv_inserted)
{
	//get poster from existing lecture
	if ($fv_stmt_lec = mysqli_prepare($pv_link,"select poster from vullo_lectures where lecture_id = ?"))
		{     
			mysqli_stmt_bind_param($fv_stmt_lec, "i", $pv_lectureId);
			mysqli_stmt_execute($fv_stmt_lec);
			mysqli_stmt_bind_result($fv_stmt_lec, $poster);
                     mysqli_stmt_store_result($fv_stmt_lec);
			while(mysqli_stmt_fetch($fv_stmt_lec)){
 				// update new lecture with the poster
				if ($fv_stmt_update_poster = mysqli_prepare($pv_link,"update vullo_lectures set poster = ? where lecture_id = ?"))
				{
					mysqli_stmt_bind_param($fv_stmt_update_poster, "si",$poster, $pv_inserted);
					mysqli_stmt_execute($fv_stmt_update_poster);
 					mysqli_stmt_close($fv_stmt_update_poster);
				}			
			}
			mysqli_stmt_close($fv_stmt_lec);
		}		
}

function copyVideoRecords($pv_lectureId, $pv_link, $pv_inserted)
{
 	if ($fv_stmt_video = mysqli_prepare($pv_link, "select video_file_name, video_type,video_length from vullo_lecture_videos where lecture_id = ?"))
		{
			mysqli_stmt_bind_param($fv_stmt_video, "i", $pv_lectureId);
			mysqli_stmt_execute($fv_stmt_video);
			mysqli_stmt_bind_result($fv_stmt_video, $video_file_name,$video_type,$video_length);
			mysqli_stmt_store_result($fv_stmt_video);
			while(mysqli_stmt_fetch($fv_stmt_video)){
				
				if ($fv_stmt_insert_video = mysqli_prepare($pv_link, "INSERT INTO Vullo_lecture_videos (`lecture_id`, `video_file_name`,`video_type`,`video_length`) VALUES (?,?,?,?)"))
        			{
            				mysqli_stmt_bind_param($fv_stmt_insert_video, "issd", $pv_inserted, $video_file_name,$video_type, $video_length);
            				mysqli_stmt_execute($fv_stmt_insert_video);  		
					mysqli_error($pv_link);       				
            				mysqli_stmt_close($fv_stmt_insert_video);
         			}
       	 	}

		}

}

function copySlides($pv_lectureId, $pv_link, $pv_inserted)
{
	if ($fv_stmt = mysqli_prepare($pv_link, "SELECT slideid,lectureid,slidenum,slide_seconds, slidetitle,slidebody,lecture_notes,student_notes FROM vullo_slides WHERE lectureid=? order by slidenum asc")) 
    		{
        		/* bind parameters for markers */
       	 	mysqli_stmt_bind_param($fv_stmt, "i", $pv_lectureId);

        		/* execute query */
        		mysqli_stmt_execute($fv_stmt);

        		/* bind result variables */
        		mysqli_stmt_bind_result($fv_stmt, $slide_id,$lecture_id,$slide_number,$slide_seconds,$slide_title,$slide_body,$lecture_notes,$student_notes);
			mysqli_stmt_store_result($fv_stmt);
        		/* fetch value */
	        	while(mysqli_stmt_fetch($fv_stmt)){
				
				if ($fv_stmt2 = mysqli_prepare($pv_link, "INSERT INTO vullo_slides (`lectureid`, `slidenum`,`slide_seconds`,`slidetitle`,`slidebody`,`lecture_notes`,`student_notes`) VALUES (?,?,?,?,?,?,?)"))
        			{
            				mysqli_stmt_bind_param($fv_stmt2, "iiissss", $pv_inserted, $slide_number,$slide_seconds, $slide_title,$slide_body,$lecture_notes,$student_notes);
            				mysqli_stmt_execute($fv_stmt2);  
					
					mysqli_error($pv_link);       				
            				mysqli_stmt_close($fv_stmt2);
         			}
       	 	}
       
       		mysqli_stmt_close($fv_stmt);
      		}

}

?>
