<?php

/*
  This file is doing operations related to video poster managment.
  Operations is defined based on t_command input parameter.
  Input parameters: t_command, t_lectureid.
  Commands supported:
    delete: deletes poster for provided lecture;
    upload: upload poster for provided lecture;
    get: return poster url (lectureid/postername) for requested lecture. To get the image, we need to append root/videotracks at the begining of return url; 
*/

include('logging.php');
include('database.php');

if(!isset($_GET["t_command"]) || !isset($_GET["t_lectureid"]))
{
    http_response_code(400);
}
$gv_command = $_GET["t_command"];
$gv_lId = $_GET["t_lectureid"];

switch($gv_command){
    case "delete":
        DeletePoster($gv_lId, $gv_link);
        break;
    case "upload":
    	Upload($gv_lId, $gv_link);
    	break;
    case "get":
	Get($gv_lId,$gv_link);
	break;
}

function DeletePoster($pv_lectureId,$pv_link){
   	if ($fv_stmt = mysqli_prepare($pv_link, "update vullo_lectures set poster = '' where lecture_id = ?")) 
			{
				mysqli_stmt_bind_param($fv_stmt, "i", $pv_lectureId);
	
				mysqli_stmt_execute($fv_stmt);
				mysqli_stmt_close($fv_stmt);
			}
}

function Get($pv_lectureId,$pv_link){
   	if ($fv_stmt = mysqli_prepare($pv_link, "select poster from vullo_lectures where lecture_id = ?")) 
			{
				mysqli_stmt_bind_param($fv_stmt, "i", $pv_lectureId);	
				mysqli_stmt_execute($fv_stmt);
				mysqli_stmt_bind_result($fv_stmt, $poster);
				mysqli_stmt_fetch($fv_stmt);
				if ($poster)			
					echo $pv_lectureId."/".$poster;
				mysqli_stmt_close($fv_stmt);
			}
}

function Upload($pv_lectureId, $pv_link){
	$fv_targetPath = "../videotracks/".$pv_lectureId."/";
	
	if (!is_dir($fv_targetPath)) {
		mkdir($fv_targetPath);
	}
	$fv_file = $_FILES['imagefile'];
	$fv_targetPath = $fv_targetPath.basename( $fv_file['name']); 
	$fv_fileType = $fv_file['type'];
	
	if (is_uploaded_file($fv_file['tmp_name'])) {
		
		if (move_uploaded_file($fv_file['tmp_name'], $fv_targetPath))
		{
			$fv_fileName = $fv_file['name'];
			
			if ($fv_stmt = mysqli_prepare($pv_link, "update vullo_lectures set poster = ? where lecture_id = ?")) 
			{
				mysqli_stmt_bind_param($fv_stmt, "si", $fv_fileName,$pv_lectureId);
	
				mysqli_stmt_execute($fv_stmt);
				mysqli_stmt_close($fv_stmt);
				echo '{"path":"'.$pv_lectureId."/".$fv_fileName.'"}';
			}
		}
		else
		{
			echo "Error uploading a file";
			echo $fv_file['error'];
			switch ($fv_file['error'])
			{
				case 1:
					print '<p> The file is bigger than this PHP installation allows</p>';
					break;
				case 2:
					print '<p> The file is bigger than this form allows</p>';
					break;
				case 3:
					print '<p> Only part of the file was uploaded</p>';
					break;
				case 4:
					print '<p> No file was uploaded</p>';
					break;
			}
		}
	}else
	{
		echo "Upload error";
	}
}
?>
