var currentCaption;

$(document).ready(function(){
	initialize();	
});


function initialize(){
	if(!lectureId){
        return;
	}
	if(g_LectureName){
		$("#lectureName_span").text(g_LectureName);
	}
	
	if(g_CourseNumber){
		$("#courseNumber_span").text(g_CourseNumber);
	}
	loadCaptions(lectureId);
	toggleCaptionContent(false);
	toggleBulkUpload(false);
	enableDeleteCaption(false);	
}




function metaDataEdit(ele){
	var container = ele.id.split('_'),
    pre = container[0];
	
	var value = $("#"+pre+"_span").text();	
	$("#"+pre+"_read").hide();
	$("#"+pre+"_write").show();	
	if(pre === "slidePreview"){
		tinyMCE.get(pre+"_input").setContent($("#"+pre+"_span").text());	
	}
	else{
		$("#"+pre+"_input").val(value);
	}	
}

function metaDataSave(ele){
	var container = ele.id.split('_'),
	pre = container[0];
	var value = $("#"+pre+"_input").val().trim(),
	prevValue = $("#"+pre+"_span").text().trim();
	isValueNotUpdated =  (prevValue === value);	
	
	if(value.trim().length > 0){
		
		if($("#"+pre+"_input").css("border-Color") == "rgb(255, 0, 0)"){
			$("#"+pre+"_input").css("border-Color", "") ;
		}
		
		switch(pre){
			case "lectureName":
			if(!(isValueNotUpdated)){
				saveLectureName(lectureId, value,function(result){
					if(result && result.success){
						metaDataPostSave(pre, value);
					}
					else{
						showMessage(result.value, true);
					}					
				});
			}
			else{
				metaDataPostSave(pre, value);
			}
			break;
			
			case"courseNumber":
			if(!(isValueNotUpdated)){
				saveCourseNumber(lectureId, value, function(result){
					if(result && result.success){
						metaDataPostSave(pre, value);
					}
					else{
						showMessage(result.value, true);
					}					
				});
			}
			else{
				metaDataPostSave(pre, value);
			}
			break;
			
			case "captionContent":
			if(!(isValueNotUpdated)){
				var captionId = currentCaption.Id;

				if(parseInt(captionId)){
					saveCaptionContent(lectureId, captionId, stripslashes(value), function(result){
						if(result && result.success){
							metaDataPostSave(pre, value);
						}
						else{
							showMessage(result.value, true);
						}						
					});
				}			
			}
			else{
				metaDataPostSave(pre, value);
			}
			break;
			
			default:
			break;
		}
	}
	else{
		$("#"+pre+"_input").css("border-Color", "#FF0000") ;
	}
}

function metaDataPostSave(prefix, value){
	hideMessage();
	$("#"+prefix+"_read").show();
	$("#"+prefix+"_span").text(value);
	$("#"+prefix+"_input").val("");
	$("#"+prefix+"_write").hide();
	
	switch(prefix){
		case "lectureName":
		g_LectureName = value;
		$("#lectureNameTitle").text(g_LectureName);
		break;
		
		case "courseNumber":
		g_CourseNumber =  value;
		$("#courseNumberTitle").text(g_CourseNumber);
		break;
		
		case "captionContent":
		currentCaption.Title = jQuery.trim(stripslashes(value)).substring(0, 30);
		redrawCaption(currentCaption);	
		break;
		
		default:
		break;			
	}
	
}

function metaDataCancel(ele){
	hideMessage();
	var container = ele.id.split('_'),
    pre = container[0];
	
	$("#"+pre+"_read").show();
	$("#"+pre+"_input").val("");
	$("#"+pre+"_input").css("border-Color", "") ;
	$("#"+pre+"_write").hide();		
}

function toggleCaptionContent(flag){
	if(flag){
		$("#captionContentDiv").show();	
	}
	else{
	    // if in edit mode reset 
		if ($("#captionContent_write").is(":visible")){
			$("#captionContent_input").html("");
			$("#captionContent_write").hide();		   
			$("#captionContent_read").show();
		}
		else{
			//clear in read only mode
			$("#captionContent_span").html("");
			$("#captionPreviewNumber").html("");
		}
		$("#captionContentDiv").hide();	
	}
	
}

function toggleBulkUpload(flag){	
	if(flag){
		$("#bulkCaptionUpload").show();
		$('#blkUpload').attr("disabled", true).fadeTo("fast", .5);
		$('#uploadBtn').attr('disabled',true);
		
		// if slide content is visible
		toggleCaptionContent(false);
	}
	else{	
		//clean up 		
		hideMessage();
	    $('#blkUpload').removeAttr("disabled", false).fadeTo("fast", 1);
		$('#txtCaptionText').val(""); 		
		$("#confirmUpload").fadeOut(500);	
		$("#uploadBtn").attr("disabled",false);
		$("#bulkCaptionUpload").hide();
		//reset dropdown	
		var obj = document.getElementById('delimiterOption');
		if(obj){
			obj.selectedIndex = 0;
			toggleDelimiterInput(obj);
		}
	}
}

function toggleDelimiterInput(obj){
	var ele = document.getElementById('delimiterInput');
	if(obj){
		if(obj.selectedIndex > 0){
			ele.style.display = 'inline'; 	 
		}				 		
		else{		
			ele.value = "";		
			ele.style.display = 'none';
		}
		$("#errDel").html('');
	}	
}

function loadCaptions(lectureId){
	getCaptionMetadata(lectureId, function(result){
		if(result && result.success){
			hideMessage();
			//success
			var captions = result.value;
			if(lecHasCaptions()){
				$.each(captions, function(index, caption){	
					appendCaptionItemToList(caption);				
				});
				
				/*enable drag and drop*/
				$("#captionsListOrdered").sortable({revert:true,axis:"y",cursor: "move", cursorAt: {top:56,left:56},stop:reOrderCaptions});
				$("#captionsListOrdered").disableSelection();
				$("#captionsListOrdered li").disableSelection();
				$("#captionsListOrdered li > *").disableSelection();
				$(".caption").disableSelection();			
			}				
		}
		else{
			//error 
			showMessage(result.value, true);
		}
		
	});
	
}


function appendCaptionItemToList(caption){
	if(caption){
		$('<li class="caption" id="caption'+ caption.Id + '" data-id="'+ caption.Id + '" onclick="captionSelected(' + caption.Id + ');"><h5>'+ jQuery.trim(caption.Title).substring(0, 30) +'</h5><span class="number">'+ (caption.Number!=0?caption.Number:"")+ '</span></li>').appendTo($("#captionsListOrdered"));
	} 
}

function reOrderCaptions(){
    var i=1;
    var order = new Array();
    $("#captionsListOrdered .caption").each(function(index,elem){
        var id = parseInt($(elem).attr("data-id"));
        captionsById[id].Number = i;
        captionsByNum[i-1] = captionsById[id];
        redrawCaption(captionsById[id]);
        order.push({Id:id,Number:i });
        i++;
	});
	
	// stringy order array manually
	
	var str = "";
	if(order){		
		for(var i = 0, len = order.length; i< len; i++){		
			str = (i>0)?str + order[i].Id + ":" + order[i].Number : order[i].Id + ":" + order[i].Number;
			if(i< len-1){
				str = str+",";				
			}
		}		
	}
	
	//save the slide order
	if( parseInt(lectureId)){
		// null for with time argument
		saveCaptionOrder(lectureId, str,0, function(result){
			if(result && result.success){
				hideMessage();
			}
			else{								
				showMessage(result.value, true);
			}			
		});
	}
	else{
		showMessage("Error: Invalid lecture id!", true);
	}    
}

function redrawCaption(caption){
    if(currentCaption && caption.Id == currentCaption.Id){
        $("#captionPreviewNumber").html(caption.Number);
	} 
    $("#caption"+caption.Id +">h5").html(jQuery.trim(caption.Title).substring(0, 30));
    $("#caption"+caption.Id +" .number").html(caption.Number);
}


function addCaption(lectureId)
{
    if(! parseInt(lectureId)){
		return ;
	}
	
	var newCaption = new Caption(0,"Edit caption to add content...", 0, 0);	
	
    saveCaption(lectureId, newCaption, function(result){
		if(result && result.success){			
			hideMessage();
			var caption = result.value;
			if(caption){
				currentCaption = caption;
				redrawCaption(caption);
				appendCaptionItemToList(caption);		 
				var container = $('#captionsListOrdered');
				container.animate({ scrollTop: $('#captionsListOrdered li:last-child').offset().top - container.offset().top + container.scrollTop() });			
				$('.caption').css({"borderColor":"black"});
				$('#caption' + caption.Id).css({"borderColor":"red"});
				
				//show caption content section
				toggleCaptionContent(true);
				/*Initially the caption will be empty*/
				$("#captionContent_span").html("");
				enableDeleteCaption(true);
			}				
		}
		else{
			showMessage(result.value, true);			
		}		    
	});
}


function captionSelected(captionId){
	if(!( parseInt(lectureId) && parseInt(captionId) )){
		return ;	
	}
	//if upload is visible
	toggleBulkUpload(false);
	
	//set current caption
	currentCaption = captionsById[captionId];
	
	//check caption exist
	if(currentCaption){
		
	 	$('.caption').css({"borderColor":"black"});
		$('#caption' + captionId).css({"borderColor":"red"});
		
		getCaptionContent(lectureId, captionId, function(result){
			if(result && result.success){
				hideMessage();
				if(!($("#captionContent_span").is(":visible"))){
					metaDataCancel($("#captionContent_Cancel")[0]);
				}
				$("#captionContent_span").html(result.value.trim());
				$("#captionPreviewNumber").html(currentCaption.Number);
				toggleCaptionContent(true);
				enableDeleteCaption(true);
			}
			else{
				showMessage(result.value, true);
			}			
		});
	}	
}

function ShowConfirmDelete(){
	var isChecked = false;
	$("#captionsListOrdered li").each(function(index, item){
		if($("#"+item.id).css("border-Color") === "rgb(255, 0, 0)"){
			isChecked = true;
		}		
	});
	if(isChecked){
		$("#confirmDelete").fadeIn(200);	
	}
}

function HideConfirmDelete(){
	$("#confirmDelete").fadeOut(500); 	
}

function enableDeleteCaption(flag){
	if(flag){
		//enable delete when slide is selected
		$('#deleteCaption').attr("disabled", false).fadeTo("fast", 1);
		$('#deleteCaption').click(ShowConfirmDelete);	
	}
	else{
		$('#deleteCaption').attr("disabled", true).fadeTo("fast", .4);
		$('#deleteCaption').unbind('click', ShowConfirmDelete);				
	}	
}

function removeCaption(lectureId){
	if((! parseInt(lectureId)) && currentCaption){
		return;	
	}
    deleteCaption(lectureId, currentCaption, function(result){
		if(result && result.success){
			hideMessage();
			$("#caption" + result.value).remove();
			toggleCaptionContent(false);		
			reOrderCaptions();
			currentCaption = null;
			//in activate delete
			enableDeleteCaption(false);	
		}
		else{
			showMessage(result.value, true);
		}		
	});
	HideConfirmDelete();
}

function stripslashes(str) {
	return (str + '')
    .replace(/\\(.?)/g, function(s, n1) {
		switch (n1) {
			case '\\':
			return '\\';
			case '0':
			return '\u0000';
			case '':
			return '';
			default:
			return n1;
		}
	});
}

function enableDisableUpload(txtObject){
	if($(txtObject).val().trim().length !=0){
		$('#uploadBtn').attr('disabled', false); 
	}           
	else{
		$('#uploadBtn').attr('disabled',true);
	}
}

function bulkCaptionUploadClicked(){
	if(validateDelimeter())	{
		var content = $('#txtCaptionText').val().trim();
		if(content.length>0){
			if($("#captionsListOrdered .caption").length == 0){ 
				bulkCaptionUploadSave();
			}
			else{
				$("#confirmUpload").show();
				$("#uploadBtn").attr("disabled",true);
			}	       
		}
	}	
}

function validateDelimeter(){
	var obj = document.getElementById('delimiterOption');
	if(obj){
		if(obj.selectedIndex > 0){
			var inputVal = $("#delimiterInput").val().trim();
			if(inputVal.length > 0){
				var pattern ;
				var index = obj.selectedIndex;
				if(index === 1){
					pattern = new RegExp('^(?=.*[1-9])\\d+$'); 
					if(! pattern.test(inputVal)){
						$("#errDel").html("Number required");
						$("#delimiterInput").val('');
						return false;
					}
					else{						
						return true;
					}					
				}
				else{
					return true;
				}				
			}
			else{
				$("#errDel").html("Required field");
				return false;
			}
		}
		else{
			$("#errDel").html('');
			return true;
		}
		
	}
	
}

function bulkCaptionUploadSave(btnObj){	
    var content = $('#txtCaptionText').val().trim();
	content = processCaptionInput(content);
	
	var overWrite = true;
	if(btnObj){
		if(btnObj.id === "btnAppend" ){
			overWrite = false;				
		}
	}
//	alert("lectureId "+lectureId+" content "+content);
	bulkUploadCaptions(lectureId, content, overWrite, function(result){
		if(result && result.success){		
			hideMessage();
			RefreshCaptions();
			//clear all captions
			$("#captionsListOrdered").empty();
			toggleBulkUpload(false);
		}
		else{
			showMessage(result.value, true);
			$("#confirmUpload").fadeOut(500);	
		}
		
	});	
}

function processCaptionInput(content){
	// remove empty lines
	var content1 = content.replace(/^\s*[\r\n]/gm," "),
	 selVal = $("#delimiterOption").val();
	content1 = content1.replace(/'/g,"`");
	if(selVal === '1'){
		// string length
		var len = $("#delimiterInput").val().trim(); 
		// replace '\n' with " "
		content1  = content1.replace(/\n/g," ");
		return wordWrap(content1, len);
	}
	else{
	if(selVal === '2'){
	// special character
	// replace '\n' with " "
	content1 = content1.replace(/\n/g," ");
	var splChar = $("#delimiterInput").val(); 

	var tokens =  content1.split(splChar),
	tkLen = tokens.length,
	content2 = '';

	for( var i =0; i< tkLen; i++){
		if(tokens[i].trim().length > 0){
			content2 += tokens[i]+"\n";
		}
		
	}

	return content2;
}
else{
	return  content1; 
}
}
}
function RefreshCaptions(){ 
	loadCaptions(lectureId);
}

function wordWrap(str, maxWidth) {
	var newLineStr = "\n", done = false, res = '';
	do {                    
		found = false;
		// Inserts new line at first whitespace of the line
		for (i = maxWidth - 1; i >= 0; i--) {
			if (testWhite(str.charAt(i))) {
				res = res + [str.slice(0, i), newLineStr].join('');
			str = str.slice(i + 1);
			found = true;
			break;
			}
			}
			// Inserts new line at maxWidth position, the word is too long to wrap
			if (!found) {
			res += [str.slice(0, maxWidth), newLineStr].join('');
			str = str.slice(maxWidth);
			}
			
			if (str.length < maxWidth){
			if(str.length > 0){
			res = res + str;					
			}
			
			done = true;
			}
			
			} while (!done);
			
			return res;
			}
			
			function testWhite(x) {
			var white = new RegExp(/^\s$/);
			return white.test(x.charAt(0));
			}
			
			
			
						