
function makeScrollable(wrapperParam, scrollable){
	// Get jQuery elements
	var wrapper = $(wrapperParam), scrollable = $(scrollable);

	// Hide images until they are not loaded
	scrollable.hide();
	var loading = $("<div class='loading'></div>").appendTo(wrapper);

	// Set function that will check if all images are loaded
	var interval = setInterval(function(){
		var images = scrollable.find("img");
		var completed = 0;

		// Counts number of images that are succesfully loaded
		images.each(function(){
			if (this.complete) completed++;
		});

		if (completed == images.length){
			clearInterval(interval);
			// Timeout added to fix problem with Chrome
			// 2018-05-22: Issue doesn't seem to exist, reducing timeout to almost zero since feels sluggish
			setTimeout(function(){

				loading.hide();
				// Remove scrollbars
				wrapper.css({overflow: "hidden"});

				scrollable.slideDown(250, function(){ // this is the speed the slidein (in ms; was 1000)
					enable();
				});
			}, 10); // delay before slidein (in ms; was 2000)
		}
	}, 200);			
			
	
	function enable(){
		// height of area at the top at bottom, that don't respond to mousemove
		var inactiveMargin = 80;					
		// Cache for performance
		var wrapperWidth = wrapper.width();
		var wrapperHeight = wrapper.height();
		// Using outer height to include padding too
		var scrollableHeight = scrollable.outerHeight() + 2*inactiveMargin;
		// Do not cache wrapperOffset, because it can change when user resizes window
		// We could use onresize event, but it's just not worth doing that 
		// var wrapperOffset = wrapper.offset();
				
		var lastTarget;
		//When user move mouse over menu			
		wrapper.mousemove(function(e){
			// Save target
			lastTarget = e.target;

			var wrapperOffset = wrapper.offset();
					
			// Scroll menu
			var top = (e.pageY -  wrapperOffset.top) * (scrollableHeight - wrapperHeight) / wrapperHeight - inactiveMargin;
			if (top < 0){
				top = 0;
			}			
			wrapper.scrollTop(top);
			 if (isTouchDevice())
		{

			  if (top <= 0)
			{
				$("#scrollup").hide();
			}else
			{
				$("#scrollup").show();
			}
			if ((scrollable.offset().top +  scrollable.height()) <= (wrapper.offset().top + wrapperHeight)) 
                    {
				$("#scrolldown").hide();
			}else
			{
				$("#scrolldown").show();
			}
		}	

		});
           if (isTouchDevice())
		{
	       var scrollInterval = 40;
		$("#scrollup").mousedown(function(e){
			var wrapperOffset = wrapper.offset();
			// Scroll menu
			var top = (wrapper.offset().top - scrollable.offset().top) - scrollInterval ;
			if (top < 0){
				top = 0;
			}			
			wrapper.scrollTop(top);
                     if (top <= 0)
			{
				$("#scrollup").hide();
			}else
			{
				$("#scrollup").show();
			}
			if ((scrollable.offset().top +  scrollable.height()) <= (wrapper.offset().top + wrapperHeight)) 
                    {
				$("#scrolldown").hide();
			}else
			{
				$("#scrolldown").show();
			}	

		});

		$("#scrolldown").mousedown(function(e){
			var wrapperOffset = wrapper.offset();
			// Scroll menu
			var top = (wrapper.offset().top - scrollable.offset().top) + scrollInterval ;
			if (top < 0){
				top = 0;
			}			
			wrapper.scrollTop(top);
                      if (top <= 0)
			{
				$("#scrollup").hide();
			}else
			{
				$("#scrollup").show();
			}
		if ((scrollable.offset().top +  scrollable.height()) <= (wrapper.offset().top + wrapperHeight)) 
                    {
				$("#scrolldown").hide();
			}else
			{
				$("#scrolldown").show();
			}

		});
		}
	
	}
}
function isTouchDevice() {
   var el = document.createElement('div');
   el.setAttribute('ongesturestart', 'return;');
   return (typeof el.ongesturestart == "function");
}
	
$(function(){	
	makeScrollable("div.sc_menu_wrapper", "div.sc_menu");
	if (isTouchDevice())
	{
		$("#scrollup").show();
		$("#scrolldown").show();
	}

});