/*
	This file supports Resources page.
	The main actions are : delete video, delete poster, get poster, upload poster
*/

// handles custom events 1) onFileSelected 2) onFileUploaded raised in filedrag.js
//registering events handlers for executing code when custom events are fired

//document.addEventListener("onFileSelected", checkIfResourceAlreadyExist, false);

// important (adding event handler for post upload processing)
document.addEventListener("onFileUploaded", postVideoUploadProcessing, false);


var videoId;
var isVideoUpload;

function ResourceResult(){
	this.success = null;
	this.value = null;

}

$(document).ready(LoadPoster);

function LoadPoster(){ 
	fetchPosterDetails(lectureId, function(result){
	    hideMessage();
		if(result && result.success){
			//poster available
			if(result.value){
				ShowImage(lectureId+"/"+result.value);
			}
			else{
				//no poster available
				ShowNoImage(); 
			}			
		}
		else{
			showMessage(result.value, true);			
		}		
	});
}

function ShowImage(path){
	$("#poster_img").attr("src","videotracks/"+path);   
	$("#poster_img").show();
	$("#addPosterBtn").hide();
	$("#deletePosterBtn").show();
}

function ShowNoImage(){
	$("#addPosterBtn").show();
	$("#deletePosterBtn").hide();
	$("#poster_img").hide();
	
}

function ShowUploadVideo(videpFlag) {
	isVideoUpload = videpFlag;	
	$("#UploadResource").show();
}

/* 
	once the resource (video or poster) has been uploaded via molly upload
	the below function is responsible for calling respective function to enter a 
	record in the database.
*/
function postVideoUploadProcessing(e){	
	if(! isVideoUpload){	
		//poster database entry
		addPosterRecord(e, postAddRecordProcessing);				
	}
	else{
		//video database entry
		addVideoRecord(e,postAddRecordProcessing);
	}
	
	/*$( document ).ajaxStop(function() {
		HideUploadVideo()
		if(isVideoUpload){
			location.reload();
		}
	});*/
}

/*
	Once the database record has been inserted the below function is responsible to 
	update the user interface.
*/

function postAddRecordProcessing(result, e){
	if(result && result.success){
		if(! isVideoUpload){
			ShowImage(lectureId +"/"+result.value);
		}		
	}
	else{
	    if(result.value){
			showMessage(result.value, true);			
			e.detail.message.filePostUploadProcessingError = true;
			e.detail.message.fileDetail = e.detail.message.data; 
		}		
	}
}


function HideUploadVideo() {	
	$("#UploadResource").fadeOut(500); 
	// commented resetUploadForm due to error 'not defined'
	//resetUploadForm();
}


//delete resource (video)
function ShowDeleteConfirmation(id){
    videoId = id;
    $("#confirmDelete").show();
}

function videoDeleteOnServer(){
	var status;
	if(lectureId && videoId){
		deleteVideo(lectureId, videoId, function(result){
		    hideMessage();
			if(result && result.success){
				status = result.success;
			}
			else{
				showMessage(result.value, true);
			}		
		});	

	}
	else{
		showMessage("Error: Invalid lecture Id  or video Id", true);				

	}
	$("#confirmDelete").hide();
	
	$( document ).ajaxStop(function() {
		if(status){
			location.reload();	
		}
	});
}

function hideConfirmation(){
    $("#confirmDelete").hide();
}



//delete resource (poster)
function ShowDeletePosterConfirmation(){
    $("#confirmDeletePoster").show();
}

function posterDelete(){
	if(lectureId){
		deletePoster(lectureId, function(result){
			hideMessage();
			if(result && result.success){
				ShowNoImage();				
			}
			else{
				showMessage(result.value, true);	
			}			
		});	
	}
	else{
		showMessage("Error: Invalid lecture Id", true);	
	}
	$("#confirmDeletePoster").hide();

}

function hideConfirmationPoster(){
    $("#confirmDeletePoster").hide();
}



//data functions

function fetchPosterDetails(lectureId, callback){
	var obj = new ResourceResult();
	$.ajax({
		url: 'commands/video/getposter.maml',
		data: {t_lectureid : lectureId},
		dataType: 'json',
		type: 'POST',
        success: function(data){
            if(data){
			    obj.success = true;
				obj.value = (data.poster && data.poster.trim().length > 0)? data.poster.trim() : null;				
			}
			if(callback){
				callback(obj);
			}			
		},
        error: function(qXHR, textStatus, errorThrown){            
			obj.success = false;
			obj.value = "Error occurred while fetching poster details!";
			//"Error: " + qXHR.statusText + ". Error code: " + qXHR.status;
			if(callback){
				callback(obj);
			}
		}
	});		

}

function addPosterRecord(e, callback){
	var obj = new ResourceResult();
	var file = e.detail.message.data; 
	$.ajax({
        url:'commands/video/addposter.maml',
        data: {t_lectureid:lectureId,t_poster:file.name},
		type:'POST',
        dataType: 'json',
        success: function(data){
			obj.success = (data && data.poster);
			obj.value =  (obj.success)? data.poster: data;
			if(callback){
				callback(obj, e);
			}		
		},
        error: function(qXHR, textStatus, errorThrown){
			obj.success = false;
			obj.value = "Error occurred while adding a poster record!";
			//"Error: " + qXHR.statusText + ". Error code: " + qXHR.status;
			if(callback){
				callback(obj, e);
			}	
		}
	});	

}

function addVideoRecord(e, callback){
	var obj = new ResourceResult();
	var file = e.detail.message.data; 
	
	
	$.ajax({
        url:'commands/video/addvideo.maml',
        type:'POST',
        data: {t_lectureid : lectureId, t_fileName : file.name, t_fileType : file.type,t_fileLength:file.size},
        dataType: 'json',		 
        success: function(data){
			obj.value = data;
			obj.success = (data == true);
			if(callback){
				callback(obj, e);	
			}			
		},
		error: function(qXHR, textStatus, errorThrown){	
			obj.success = false;
			obj.value = "Error occurred while adding a video record!";
			//"Error: " + qXHR.statusText + ". Error code: " + qXHR.status;
			if(callback){
				callback(obj, e);
			}
		}		
	});
}

function deleteVideo(lectureId, videoId, callback){  
	var obj = new ResourceResult();
    $.ajax({      
		url:'commands/video/deletevideo.maml',        
		data: {t_lectureid:lectureId,t_videoid:videoId},
        dataType: 'json',
		type: 'POST',
        success: function(data){
			
		},
        error: function(qXHR, textStatus, errorThrown){ 			
			obj.success = (qXHR.status === 200);
			if(! obj.success){
				obj.value = "Error occurred while deleting the video!" 
				//"Error: " + qXHR.statusText + ". Error code: " + qXHR.status;
			}	
			if(callback){
				callback(obj);
			}			
		}
	});
}

function deletePoster(lectureId, callback){
	var obj = new ResourceResult();
    $.ajax({        
		url: 'commands/video/deleteposter.maml',        
		data:{t_lectureid:lectureId},
		type:'POST',
		dataType:'json',
        success: function(data){
			if(data && data.success){
				obj.success = true;
				obj.value = data.success;
			}
			else{
				obj.success = false;
				obj.value = "Error occurred while while deleting the poster!";
			}
			if(callback){
				callback(obj);
			}
			
		},
        error: function(qXHR, textStatus, errorThrown){            
			obj.success = false;
			obj.value = "Error occurred while while deleting the poster!";
			//"Error: " + qXHR.statusText + ". Error code: " + qXHR.status;
			if(callback){
				callback(obj);
			}
		}
	});
}

function cleanYouTubeURL() {
	$("#youtube-url").val(function() {
		// two syntaxes:
		// 1) https://www.youtube.com/watch?v=VIDEOIDHERE&t=bleh....
		// 2) https://youtu.be/VIDEOIDHERE?t=blah...
		var text = $("#youtube-url").val();
		
		// Search for v= declatation of video ID in youtube.com links
		if(text.indexOf("v=") != -1) {
			text = text.substr(text.indexOf("v=") + 2);
		}
		// remove trailing parameters if exist (time, etc.)
		if(text.indexOf("&") != -1) {
			text = text.substr(0, text.indexOf("&"));
		}
		// remove initial parameter if exists (for example, the youtu.be links w/ time)
		if(text.indexOf("?") != -1) {
			text = text.substr(0, text.indexOf("?"));
		}
		// remove unwanted leading stuff (for youtu.be links)
		while(text.indexOf("/") != -1) {
			text = text.substr(text.indexOf("/") + 1);
		}
		
		return text;
	});
}
