window.onload = function() {

	// Video
	var video = document.getElementById("lecture");

	// Buttons
	var playButton = document.getElementById("play-pause");
	var muteButton = document.getElementById("mute");
	var fullScreenButton = document.getElementById("full-screen");

	// Sliders
	var seekBar = document.getElementById("seek-bar");
	var volumeBar = document.getElementById("volume-bar");


	// Event listener for the play/pause button
	playButton.addEventListener("click", function() {
		if (video.paused == true) {
			// Play the video
			video.play();

			// Update the button text to 'Pause'
			playButton.innerHTML = '<i class="material-icons">pause</i>';
			playButton.name = 'pause'
		} else {
			// Pause the video
			video.pause();

			// Update the button text to 'Play'
			playButton.innerHTML = '<i class="material-icons">play_arrow</i>';
			playButton.name = 'play'
		}
	});


	// Event listener for the mute button
	muteButton.addEventListener("click", function() {
		if (video.muted == false) {
			// Mute the video
			video.muted = true;

			// Update the button text
			muteButton.innerHTML = '<i class="material-icons">volume_off</i>';
		} else {
			// Unmute the video
			video.muted = false;

			// Update the button text
			muteButton.innerHTML = '<i class="material-icons">volume_mute</i>';
		}
	});


	// Event listener for the full-screen button
	fullScreenButton.addEventListener("click", function() {
		if (video.requestFullscreen) {
			video.requestFullscreen();
		} else if (video.mozRequestFullScreen) {
			video.mozRequestFullScreen(); // Firefox
		} else if (video.webkitRequestFullscreen) {
			video.webkitRequestFullscreen(); // Chrome and Safari
		}
	});



	var pfx = ["webkit", "moz", "ms", "o", ""];
	function RunPrefixMethod(obj, method) {
		
		var p = 0, m, t;
		while (p < pfx.length && !obj[m]) {
			m = method;
			if (pfx[p] == "") {
				m = m.substr(0,1).toLowerCase() + m.substr(1);
			}
			m = pfx[p] + m;
			t = typeof obj[m];
			if (t != "undefined") {
				pfx = [pfx[p]];
				return (t == "function" ? obj[m]() : obj[m]);
			}
			p++;
		}
	
	}




	// Event listener for the full-screen page button
	var fullScreenPageButton = document.getElementById("full-screen-page");
	var page = document.getElementById("frame");
	fullScreenPageButton.addEventListener("click", function() {
	
		if (RunPrefixMethod(page, "FullScreen") || RunPrefixMethod(page, "IsFullScreen")) {
			RunPrefixMethod(page, "CancelFullScreen");
		} else {
			RunPrefixMethod(page, "RequestFullScreen");
		}

	});


	// Event listener for the seek bar
	seekBar.addEventListener("change", function() {
		// Update the video time
		video.currentTime = video.duration * (seekBar.value / 100);
	});

	
	// Update the seek bar as the video plays
	video.addEventListener("timeupdate", function() {
		// Update the slider value
		seekBar.value = (100 / video.duration) * video.currentTime;
	});

	// Pause the video when the seek handle is being dragged
	seekBar.addEventListener("mousedown", function() {
		video.pause();
	});

	// Play the video when the seek handle is dropped
	seekBar.addEventListener("mouseup", function() {
		if (playButton.name == 'pause') {
			video.play();
		}
	});

	// Event listener for the volume bar
	volumeBar.addEventListener("change", function() {
		// Update the video volume
		video.volume = volumeBar.value;
	});
}

function linkPause() {
	var video = document.getElementById("lecture");

	// Buttons
	var playButton = document.getElementById("play-pause");

	video.pause();

	// Update the button text to 'Play'
	playButton.innerHTML = '<i class="material-icons">play_arrow</i>';
	playButton.name = 'play';
}