
// timeline object 
// created to avoid variable littering
function TimeLine(itemContainer, undoCmd){
	this.tlTop = 25,
	this.tlHeight = 10,
	this.tlArrowSize = 10,
	this.tlBottom = this.tlTop + this.tlHeight,
	this.tlMargin = 50,
	this.tlWidth = 883,
	this.width = 40,
	this.height = 90,
	this.stage = null,
	this.loadedItems = false,
	this.videoCursor = null,
	this.tlOffset = (this.tlMargin - (this.width/2)),
	this.items = [],
	this.itemsOnTimeLine = {},
	this.moveHistory = [],
	this.undo = undoCmd;
	this.itemContainer = itemContainer
}

var videoTotalTime = 0;

// object to return values
function ResultTl(){
	this.success = null;
	this.value= null;	
}

function ItemChange(id,time){
    this.Id=id; //keep 0 in order to know it's a new item.
    this.Time=time;
}

$(document).ready(init);

function init(){
	if(!lectureId){
        return;
	}
	//tabs -JQuery
	$( "#timelineTabs" ).tabs();
	
	toggleVideoContainer();
	
	$(window).resize(function() {
		toggleVideoContainer();
	});
}

function toggleVideoContainer(){
	if($("#videoplayer source").length > 0){
		$("#videoUploader").hide();
		$("#videocontainer").show();
		$("#timelineTabs").show();
		initVideo();
	}
	else{
		$("#videoUploader").show();
		$("#videocontainer").hide();
		$("#timelineTabs").hide();
	}
}


// YouTube
var vidData, player;
function onYouTubeIframeAPIReady() {
	player = new YT.Player('videoPlayerDiv', {
		height: '100%',
		width: '100%',
		videoId: vidData.source,
		playerVars: {
			'cc_load_policy': 1,
			'showinfo': 0,
			'rel': 0
		},
		events: {
			'onReady': onPlayerReady
		}
	});
}
function onPlayerReady(event) {
	event.target.playVideo();
	
	var slideTL   = new TimeLine('tlSlideContainer', 'undocommand'),
	captionTL = new TimeLine('tlCaptionContainer', 'undoCaptioncommand'),
	errorSlide = null;
	
	//hide undo 	
	$("#"+slideTL.undo).hide();
	$("#"+captionTL.undo).hide();
	hideMessage();
	
	videoTotalTime = event.target.getDuration();				
	var setLengthOfVideo = [];

	//checking if length of any one source is zero i.e. video has been uploaded recently
	//if so save video length using video tag duration

	setLengthOfVideo.push(videoTotalTime);
	
	if(setLengthOfVideo.length > 0){
		$.each(setLengthOfVideo, function(index, val){
			//saving duration for video id's
			saveVideoLength(videoTotalTime, val, function(result){
				if(!(result && result.success)){
					showMessage(result.value, true);	
				}
			});
		})		  		
	}

	// gets and load slides data
	getSlidesMetadata(function(result){
		if(result && result.success){
			slideTL.items = result.value;
			if(slideTL.items.length > 0){
				setTimeLineStage(slideTL);
				initItemTimes(slideTL);							
				$("#"+slideTL.undo).on('click', function(){
				tlUndo(slideTL);});
	
				window.setInterval(function() {
					updateTimeCursor(slideTL);
				}, 500);
			}
		}
		else{
			errorSlide = result.value;
		}

	});

	// gets and load caption data
	getCaptionMetadata(lectureId, function(result){
		if(result && result.success){
			captionTL.items =  result.value;
			if(captionTL.items.length > 0){
				setTimeLineStage(captionTL);
				initItemTimes(captionTL);
				$("#"+captionTL.undo).on('click', function(){
				tlUndo(captionTL);});
	
				window.setInterval(function() {
					updateTimeCursor(captionTL);
				}, 500);								
			}
			if(errorSlide){
				showMessage(errorSlide, true);
			}
			else{
				hideMessage();	
			}
		}
		else{				
			if(errorSlide){
				errorSlide = errorSlide + " " + result.value;
				showMessage(errorSlide, true);
			}
			else{
				showMessage(result.value, true);
			}
		}				
	});
	
	//window.setTimeout(function() {
				var vidPlayer = document.querySelector('iframe#videoPlayerDiv');
				if(vidPlayer !== null) {
					vidPlayer.style.height = (vidPlayer.offsetWidth / 16 * 9) + "px";
				}
	//}, 1);
}

function initVideo(){
	var v = document.getElementById("videoplayer");
	v.querySelectorAll("#videoPlayerDiv source[type='youtube']").forEach(function(item) {
		var tag = document.createElement('script');
		tag.src = "https://www.youtube.com/iframe_api";
		var firstScriptTag = document.getElementsByTagName('script')[0];
		firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
		document.getElementById('videocontrols').style = "display:none";
		vidData = { source: item.src.split('/').pop() };
		v = false;
	});
	
	if(v){
		var slideTL   = new TimeLine('tlSlideContainer', 'undocommand'),
		captionTL = new TimeLine('tlCaptionContainer', 'undoCaptioncommand'),
		errorSlide = null;

		//hide undo 	
		$("#"+slideTL.undo).hide();
		$("#"+captionTL.undo).hide();
		hideMessage();

		v.addEventListener('loadedmetadata', function() {
			videoTotalTime = this.duration;				
			var setLengthOfVideo = [];
			
			//checking if length of any one source is zero i.e. video has been uploaded recently
			//if so save video length using video tag duration
			
			$("#videoplayer source").each(function(index, ele){
				var attr1 = ele.attributes["data-length"],
				attr2  = ele.attributes["data-id"];
				if(attr1 && attr2){
					if(attr1.nodeValue === 0){
						if(attr2.nodeValue && parseInt(attr2.nodeValue)){
							// push videoId into array 
							setLengthOfVideo.push(attr2.nodeValue);
						}					
					}
				}	
			});
			// 
			if(setLengthOfVideo.length > 0){
				$.each(setLengthOfVideo, function(index, val){
					//saving duration for video id's
					saveVideoLength(videoTotalTime, val, function(result){
						if(!(result && result.success)){
							showMessage(result.value, true);	
						}
					});
				})		  		
			}
			
			// gets and load slides data
			getSlidesMetadata(function(result){
				if(result && result.success){
					slideTL.items = result.value;
					if(slideTL.items.length > 0){
						setTimeLineStage(slideTL);
						initItemTimes(slideTL);							
						$("#"+slideTL.undo).on('click', function(){
						tlUndo(slideTL);});							
						v.addEventListener('timeupdate', function(){
							updateTimeCursor(slideTL);
						});
						
					}
				}
				else{
					errorSlide = result.value;
				}
				
			});
			
		    // gets and load caption data
			getCaptionMetadata(lectureId, function(result){
				if(result && result.success){
					captionTL.items =  result.value;
					if(captionTL.items.length > 0){
						setTimeLineStage(captionTL);
						initItemTimes(captionTL);
						$("#"+captionTL.undo).on('click', function(){
						tlUndo(captionTL);});	
						
						v.addEventListener('timeupdate', function(){
							updateTimeCursor(captionTL);
						});									
					}
					if(errorSlide){
						showMessage(errorSlide, true);
					}
					else{
						hideMessage();	
					}
				}
				else{				
					if(errorSlide){
						errorSlide = errorSlide + " " + result.value;
						showMessage(errorSlide, true);
					}
					else{
						showMessage(result.value, true);
					}
				}				
			});
			
		});	
	}	
}

function setTimeLineStage(tlObj){
	/* step 1.*/	var totalWidth = calculateTimeLineWidth(tlObj);
	/* step 2.*/	initStage(tlObj, totalWidth);
	/* step 3.*/	initLayer(tlObj);
	/* step 4.*/	addTimeLineItems(tlObj);
}

function calculateTimeLineWidth(tlObj){
	var intervals = tlObj.tlWidth/(tlObj.width + 10),
	itemCount = tlObj.items.length,
	totalWidth = tlObj.tlWidth;
	
	//if item count greater than intervals then expand length
	if(itemCount > Math.floor(intervals)){
		totalWidth = ((tlObj.width+10) * itemCount)
	}
	
	tlObj.tlWidth = totalWidth - tlObj.tlMargin * 2;
	return totalWidth;
}

function initStage(tlObj, totalWidth){
	if(tlObj.stage) {
		tlObj.stage.clear();
		tlObj.stage.reset();
		tlObj.stage.setWidth(totalWidth);
	}
	else{
		tlObj.stage = new Kinetic.Stage({
			container: tlObj.itemContainer,
			width: totalWidth,
			height: 150
		});
	}
}

function initLayer(tlObj){
	var rect = new Kinetic.Rect({
		x: tlObj.tlMargin,
		y: tlObj.tlTop,
		width: tlObj.tlWidth,
		height: tlObj.tlHeight,
		fill: 'blue',
		stroke: 'black',
		strokeWidth: 1
	});
	var layer = new Kinetic.Layer();
	layer.add(rect);
	tlObj.stage.add(layer);
}

function initTimeLineItems(item, tlObj){
	var tlItem = {
		arrow : null,
		dot   : null,
		title : null,
		timing : null,
		number : null,
		rect : null	
	};
	
	tlItem.arrow = new Kinetic.Line({
		points:[tlObj.width/2, tlObj.tlBottom + tlObj.tlArrowSize, tlObj.width/2, tlObj.tlBottom],
		stroke:'black'
	});
	
	tlItem.dot = new Kinetic.Circle({
		x: tlObj.width/2,
		y: tlObj.tlTop + tlObj.tlHeight/2,
		radius:tlObj.tlHeight/2,
		fill:'cyan'
	});
	
	tlItem.title = new Kinetic.Text({
		//added to shorten the caption title when captions placed vertically.
		text: ((item.Title).length>0) ? item.Title.substring(0,10) : item.Title,
		x: tlObj.width/2 + 6, 
		y: tlObj.tlBottom + tlObj.tlArrowSize + 25, 
		width: tlObj.height - 25, 
		height:tlObj.width,
		fill:'black',
		fontSize:'12',
		rotationDeg:90
	});
	
	/*All new items have time 0, we will display 'not set' text for these item with exception to the first item that has real 0 time*/
	tlItem.timing = new Kinetic.Text({
		text:(item.Time === 0 && item.Number !== 1)?"Not Set": getTimeText(item.Time), 
		width: tlObj.width,
		align:'center',
		y: tlObj.tlTop-20, 
		fill:'black',
	textStrokeWidth: 1}); 
	
	tlItem.number = new Kinetic.Text({
		text: item.Number, 
		width: tlObj.width,
		align:'center',
		padding:3,
		fontSize:'14px',
		y:tlObj.tlTop + tlObj.tlArrowSize + 20 , 
		fill:'black',
	textStrokeWidth:1});
	
	tlItem.rect = new Kinetic.Rect({
		x: 0,
		y: tlObj.tlBottom + tlObj.tlArrowSize,
		width: tlObj.width,
		height: tlObj.height,
		fill: 'white',
		stroke: 'black',
		strokeWidth: 1,
		cornerRadius:5,
	});	
	return tlItem;
}

function addTimeLineItems(tlObj){
	//iterate items
	var tlItem;
	$.each(tlObj.items.reverse(), function(index, item){
		if(item){
			tlItem = initTimeLineLayer(item, tlObj);  
			tlObj.itemsOnTimeLine[item.Id] = tlItem; 
			tlObj.stage.add(tlItem);
		}
	});	
} 

function initTimeLineLayer(item, tlObj){
	
	var itemsTL = initTimeLineItems(item, tlObj);
	
	/* we need to position all new items at the end of timeline. 
	All new items will have a time of 0. We do  need to ignore first item with time 0*/
	var newlayer = new Kinetic.Layer(
	{  x:(item.Number != 1 && item.Time == 0) || (item.Time > videoTotalTime)? getXFromTime(videoTotalTime, tlObj): getXFromTime(item.Time, tlObj), 
		draggable:true, 
		dragBoundFunc: function(pos) { 
			/*constrains horizontally the drag and drop*/
			var resx =(pos.x <= tlObj.tlOffset)?tlObj.tlOffset:pos.x; 
			resx = (pos.x >= tlObj.tlWidth + tlObj.tlOffset )?(tlObj.tlWidth + tlObj.tlOffset - 2):resx;  
			return { x:resx, 
				y: this.getAbsolutePosition().y 
			}
		}
	});
	
	//events on time line
	newlayer.on('dragmove',function(){
		itemsTL.timing.setText(getTimeText(getTimeFromX(this.getX(), tlObj)));
	});
	
	//events on time line
	newlayer.on('dragend',function(){
		var time = getTimeFromX(this.getX(),tlObj);  
		tlObj.moveHistory.push(new ItemChange(item.Id,item.Time));
		
		$("#"+tlObj.undo).show();
		item.Time = time;
		itemsTL.timing.setText(getTimeText(time));
		
		
		var videoElem = document.getElementById("videoplayer");
		if(videoElem && ! isNaN(videoElem.duration)){       
			videoElem.currentTime = Math.ceil(time);
		}		
		else{
			tlObj.videoCursor.setX(getXFromTime(time, tlObj) + tlObj.width/2 - 5);
			tlObj.videoCursor.draw();
		}
		reOrderItems(tlObj);
	});
	
	newlayer.add(itemsTL.rect);
	newlayer.add(itemsTL.timing);
	newlayer.add(itemsTL.number);
	newlayer.add(itemsTL.title);     
	newlayer.add(itemsTL.arrow);
	newlayer.add(itemsTL.dot);	 
	newlayer.item = item;
	newlayer.setTime = function(time){ 
		timing.setText(getTimeText(time));
		item.Time = time;
	};
	
	//events on time line
	newlayer.update = function(){
		itemsTL.timing.setText((item.Time === 0 && item.Number != 1)?"Not Set": getTimeText(item.Time));
		//added to shorten the caption title when captions placed vertically.
		var titleStr = ((item.Title).length>0)? item.Title.substring(0,10) : item.Title;        
		itemsTL.title.setText(titleStr); 
		itemsTL.number.setText(item.Number); 
		newlayer.setX((item.Number != 1 && item.Time ==0) || (item.Time > videoTotalTime)? getXFromTime(videoTotalTime, tlObj): getXFromTime(item.Time, tlObj));	
		newlayer.draw();
	};
	
	return newlayer;
}

function initItemTimes(tlObj){
	var layer = new Kinetic.Layer({
		x: getXFromTime(videoTotalTime,tlObj) + 25,
	y: tlObj.tlTop-2});
	
	var videoTime = new Kinetic.Text({
		x:0,
		width:50,
		text:getTimeText(videoTotalTime),
		align:'left',
		fill:'black',
		fontStyle:'normal',
		fontFamily:'Arial',
	textStrokeWidth:1});
	
	
	var itemCursor = new Kinetic.Layer({ x: getXFromTime(0, tlObj) + tlObj.width/2 - 5, y : tlObj.tlTop-6});
	
	var cursorShape1 = new Kinetic.Polygon({
		points: [0, 0, 10, 0, 5, 5],
		fill: "#FF0000",
		stroke: "red",
		strokeWidth: 1
	});
	
	var cursorShape2 = new Kinetic.Polygon({
		points: [0, tlObj.tlHeight + 6 + 6, 10, tlObj.tlHeight + 6 + 6, 5, tlObj.tlHeight + 6 + 1],
		fill: "#FF0000",
		stroke: "red",
		strokeWidth: 1
	});
	
	itemCursor.add(cursorShape1);
	itemCursor.add(cursorShape2);   
	layer.add(videoTime);
	tlObj.stage.add(itemCursor);
	tlObj.stage.add(layer);	
	tlObj.videoCursor =  itemCursor;				
}


function reOrderItems(tlObj){
	var isSlide = (tlObj.itemContainer === "tlSlideContainer");
	var order = (isSlide)? slidesByNum : captionsByNum;
	//assigning function based on Slide or Caption
	var saveOrderFunc = (isSlide) ? saveSlideOrder : saveCaptionOrder;
	var str = "";
	if(order){		
		for(var i = 0, len = order.length; i< len; i++){		
			str = (i>0) ? str + order[i].Id + ":" + order[i].Number + ":" + order[i].Time : order[i].Id + ":" + order[i].Number + ":" + order[i].Time;
			if(i< len-1){
				str = str+",";				
			}
		}		
	}
	
	saveOrderFunc(lectureId, str, true, function(result){
		if(result && result.success){
			hideMessage();
			//update
			$.each(tlObj.itemsOnTimeLine,function(index,layer){
				layer.update();
			});
		}
		else{
			//error
			showMessage(result.value, true);	
		}
	});	
}

function tlUndo(tlObj){
	var itemArray = (tlObj.itemContainer === "tlSlideContainer")?slidesById : captionsById;
	var slideChange = tlObj.moveHistory.pop();
	if(slideChange !== undefined){
		itemArray[slideChange.Id].Time = slideChange.Time;
		reOrderItems(tlObj);
	}
	if(tlObj.moveHistory.length == 0){
		$("#"+tlObj.undo).hide();
	}
}

function updateTimeCursor(tlObj){
	var cTime;
	if(player != null) {
		cTime = player.getCurrentTime();
	} else {
		var video = document.getElementById("videoplayer");
		cTime = video==null ? 0 : video.currentTime;
	}
	
	if(tlObj.videoCursor){
		tlObj.videoCursor.setX(getXFromTime(cTime, tlObj) + tlObj.width/2 - 5);
		tlObj.videoCursor.draw();						
	}
}

/*Helper methods */
function getTimeFromX(x, tlObj){
	var videoTime = videoTotalTime;
	var xMin = tlObj.tlOffset;
	var xMax = tlObj.tlOffset + tlObj.tlWidth ;
	var resx = x*videoTime/(xMax-xMin) - videoTime/(xMax-xMin)* tlObj.tlOffset;
	if(resx<0.01)
	resx=0;
	return resx;
}

function getXFromTime(time, tlObj){
	var videoTime = videoTotalTime;
	var xMin = tlObj.tlOffset;
	var xMax = tlObj.tlOffset + tlObj.tlWidth;
	return (xMax-xMin)*time/videoTime + tlObj.tlOffset;
}

function getTimeText(time){
	var hours = Math.floor(time/3600);
	var minutes = Math.floor((time - hours*3600)/60);
	var seconds = Math.ceil(time - hours * 3600 - minutes*60);
	return hours>0?(hours + ":"):"" + zeroPad(minutes,2) + ":" + zeroPad(seconds,2);
}

function zeroPad(num, places) {
	var zero = places - num.toString().length + 1;
	return Array(+(zero > 0 && zero)).join("0") + num;
}

/* Video length save */

function saveVideoLength(videoLength, videoID, callback)
{
	var obj = new ResultTl();
	$.ajax({               
		url: 'commands/video/savevideolength.maml',
		data:{t_lectureid:lectureId, t_length:videoLength, t_videoId : videoID},
		type:'POST',
        success: function(data){
			obj.success = true;
			if(callback){
				callback(obj);	
			}
		},
        error: function(qXHR, textStatus, errorThrown){
            //alert(errorThrown);
			obj.success = false;
			obj.value = "Error occurred while saving video length!";
			if(callback){
				callback(obj);	
			}
		}
	});
	
}



/*Video delete methods */ 

function confirmVideoDelete(){
	$("#confirmDelete").show();
}

function hideconfirmVideoDelete(){
	$("#confirmDelete").hide();
}

function deleteVideo(){
	var videoId = $("#videoplayer source").attr("data-id");
	
	if(parseInt(lectureId) && parseInt(videoId)){
		videoDeleteOnServer(lectureId, videoId, function(result){
			if(result && result.success){
				hideMessage();
				$("#videoplayer").remove();
				//initVideo();
				toggleVideoContainer();				
			}
			else{
				showMessage(result.value, true);				
			}			
		});
		$("#confirmDelete").hide();
	}	
}

function videoDeleteOnServer(lectureId, videoId, callback){
	var obj = new ResultTl();
	$.ajax({
		url: 'commands/video/deletevideo.maml',
		data: {t_lectureid:lectureId,t_videoid:videoId},
		dataType: 'text',
		success: function(data){
			if(data && callback){
				obj.success = true;
				callback(obj);
			}
		},
		error: function(qXHR, textStatus, errorThrown){
			//alert(errorThrown);			
			obj.success = false;
			obj.value = "Error occurred while deleting video!";
		    if(callback){
				callback(obj);	
			}	
		}
	});
}




