/*
This file is for uploading files to the server.

*/

var iPreviousBytesLoaded = 0;
var iMaxFilesize = 100048576; // 1MB
var iBytesUploaded = 0;
var iBytesTotal = 0;
var videoFilter = /^(video\/((x-m4v)|(mp4)|(ogg)|(WebM)))$/i;	
var imageFilter = /^(image\/bmp|image\/gif|image\/jpeg|image\/png|image\/tiff|jpg|jpeg|png|bmp|gif)$/i;
var isVideoUpload = true;
var imageExtensions = new Array();
  	 imageExtensions [0] = 'jpg';
        imageExtensions [1] = 'jpeg';
        imageExtensions [2] = 'bmp';
        imageExtensions [3] = 'png';
        imageExtensions [4] = 'gif';
        imageExtensions [5] = 'tif';
        imageExtensions [6] = 'tiff';

var videoExtensions = new Array();
  	 videoExtensions [0] = 'm4v';
        videoExtensions [1] = 'mp4';
        videoExtensions [2] = 'ogg';
        videoExtensions [3] = 'webm';

function checkFileExtension(elem, validExtensions) {
        var filePath = elem.name;


        if(filePath.indexOf('.') == -1)
            return false;
        
        var ext = filePath.substring(filePath.lastIndexOf('.') + 1).toLowerCase();

        for(var i = 0; i < validExtensions.length; i++) {
            if(ext == validExtensions[i])
                return true;
        }
        return false;
    }

function fileSelected() {
	    var input = document.getElementById('imagefile');
	    resetErrorMessages();
           var files = input.files;
    	    if (!files) {
           // IE9 and early versions don't support html5 file api like formdata. 
        	alert("Your browser version doesn't support HTML5 file upload. Please use IE 10, Chrome, Firefox, Opera or Safari for file upload");
		return;
    	     }
	 
	    // get selected file element
	    var oFile = files[0];
	 

	    // !! Unfortunatly HTML5 filtering doesnt work in some browsers like SAFARI, so we will switch to the simple file extension check
	    // filter for image files
	    //var rFilter = videoFilter;
           //if (!isVideoUpload)
	    //rFilter = imageFilter;	
	    //if (! rFilter.test(oFile.type)) {
           //   alert ("type not supported: " + oFile.type);
	    //    document.getElementById('error').style.display = 'block';
	    //   return;
	    //}
          
          var array = videoExtensions;
           if (!isVideoUpload)
		array = imageExtensions;
          if (!checkFileExtension(oFile, array))
	   {
            alert ("type not supported: " + oFile.type);
	        document.getElementById('error').style.display = 'block';
	       return;

	    }
	 
	    // little test for filesize
/*	    if (oFile.size > iMaxFilesize) {
	        document.getElementById('warnsize').style.display = 'block';
	        return;
	    }*/
	    $("#uploadBtn").removeAttr("disabled");
          
	}

	function resetUploadForm()
	{
		resetErrorMessages();
		document.getElementById('progress').style.display = 'none';

	       var oUploadResponse = document.getElementById('uploadresponse');
	    		oUploadResponse.innerHTML = '';
              var control = $("#imagefile");
		control.replaceWith( control.val('').clone( true ) );
		$("#uploadBtn").attr('disabled','disabled');
		$("#cancelBtn").removeAttr("disabled");	       
	}

	function resetErrorMessages()
	{
	    document.getElementById('uploadresponse').style.display = 'none';
	    document.getElementById('error').style.display = 'none';
	    document.getElementById('error2').style.display = 'none';
	    document.getElementById('abort').style.display = 'none';
	    document.getElementById('warnsize').style.display = 'none';
	    document.getElementById('progresspercent').innerHTML = '';
	}

	function startUploading(lectureId) {
	     if ($("#cancelBtn").length)
		$("#cancelBtn").attr('disabled','disabled');
	    // cleanup all temp states
	    iPreviousBytesLoaded = 0;
	    resetErrorMessages();
	    var oProgress = document.getElementById('progress');
	    oProgress.style.display = 'block';
	    oProgress.style.width = '0px';
	 
	    // get form data for POSTing
	    //var vFD = document.getElementById('upload_form').getFormData(); // for FF3
           

	    var vFD = new FormData(document.getElementById('uploadform'));
	 
	    // create XMLHttpRequest object, adding few event listeners, and POSTing our data
	    var oXHR = new XMLHttpRequest();
	    oXHR.upload.addEventListener('progress', uploadProgress, false);
	    oXHR.addEventListener('load', uploadFinish, false);
	    oXHR.addEventListener('error', uploadError, false);
	    oXHR.addEventListener('abort', uploadAbort, false);
	    if (isVideoUpload)
	    	oXHR.open('POST', 'commands/video.html?t_lectureid=' + lectureId + '&t_command=upload');
	    else 
		oXHR.open('POST', 'commands/poster.php?t_lectureid=' + lectureId + '&t_command=upload');

	    oXHR.send(vFD);
	}

	function uploadProgress(e) { // upload process in progress
	    if (e.lengthComputable) {
	        iBytesUploaded = e.loaded;
	        iBytesTotal = e.total;
	        var iPercentComplete = Math.round(e.loaded * 100 / e.total);
	 
               document.getElementById('progresspercent').innerHTML = iPercentComplete.toString() + '%';
	        document.getElementById('progress').style.width = (iPercentComplete * 4).toString() + 'px';
	        if (iPercentComplete == 100) {
	            var oUploadResponse = document.getElementById('uploadresponse');
	            oUploadResponse.innerHTML = '<h1>Please wait...processing</h1>';
	            oUploadResponse.style.display = 'block';
	        }
	    } else {
	        document.getElementById('progress').innerHTML = 'unable to compute';
	    }
	}
	function uploadFinish(e) { // upload successfully finished
		try{
		var video = $.parseJSON(e.target.responseText);
		}catch(ex)
		{
			var oUploadResponse = document.getElementById('uploadresponse');
	    		oUploadResponse.innerHTML = e.target.responseText;
	    		oUploadResponse.style.display = 'block';	
			if ($("#cancelBtn").length)
				$("#cancelBtn").removeAttr("disabled");
		
			return;
		}
		if (isVideoUpload)
		{
			if ($("#videocontainer").length)
			{
				$("#videocontainer").prepend('<video id="videoplayer" preload="true">' 
				+ '<source src="videotracks/' + video.lectureId + '/' + video.name + '" type="' + video.type + '" data-length="' + video.length + '"/>'
				+ '</video>');
				videoload();
			}
		}else
		{
			HideUploadVideo();
			if (video.path != '')
			{
				ShowImage(video.path);
				return;
			}
				
		}
            	 
	    document.getElementById('progresspercent').innerHTML = '100%';
	    document.getElementById('progress').style.width = '400px';
	    window.location.reload();

	}
	 
	function uploadError(e) { // upload error
	    document.getElementById('error2').style.display = 'block';
	} 
	 
	function uploadAbort(e) { // upload abort
	    document.getElementById('abort').style.display = 'block';
	}
