// handles custom events 1) onFileSelected 2) onFileUploaded raised in filedrag.js

//registering events handlers for executing code when custom events are fired

document.addEventListener("onFileSelected", checkIfVideoAlreadyExist, false);
document.addEventListener("onFileUploaded", postVideoUploadProcessing, false);


function checkIfVideoAlreadyExist (e){
	if(e){
		getVideoTypesForLecture(e, matchVideoTypes);		
	}
}

function matchVideoTypes(types, e ){
	var files = e.detail.message.data;
	for (var i = 0, f; f = files[i]; i++) {
		if(types.indexOf(f.type) >=0){
			e.detail.message.fileAlreadyExist = true;
			e.detail.message.fileDetail = f;
			break;
		}
	}	
}

function postVideoUploadProcessing (e){
	var file = e.detail.message.data,
	path = e.detail.message.path;
	verifyuploadedFile( e, path+file.name, file, addVideorecord);					
}

function verifyuploadedFile(e, path, file, callback){
	$.ajax({
		type: 'HEAD',
		url: path,
		success: function(msg){
			if(callback){
				callback(e, file);		
			}
		},
		error: function(jqXHR, textStatus, errorThrown){
			e.detail.message.filePostUploadProcessingError = true;
			e.detail.message.fileDetail = e.detail.message.data;
		}
	});	
}

function getVideoTypesForLecture(e, callback){
	$.ajax({
        url:'commands/video/verifyvideoexist.maml',
        type:'POST',
        data: {t_lectureid:lectureId},
        dataType: 'text',	
        success: function(data){           	
			if(data && callback){
				if(data.trim().length > 0 )
				callback(data.trim(), e); 				
			}			
		},
        error: function(qXHR, textStatus, errorThrown){
			alert(errorThrown);
			
		}
		
	});
}

function addVideorecord(e, file){
	//check video exist	
	$.ajax({
        url:'commands/video/addvideo.maml',
        type:'POST',
        data: {t_lectureid : lectureId, t_fileName : file.name, t_fileType : file.type},
        dataType: 'json',		 
        success: function(data){
			if(! data){				
				e.detail.message.filePostUploadProcessingError = true;
				e.detail.message.fileDetail = e.detail.message.data;   
			}		
		},
        error: function(qXHR, textStatus, errorThrown){
            alert(errorThrown);
			
		}
		
	});
	
}



