//global variables
// 1. g_Poster
// 2. g_EnableComments
// 3. lectureId
// 4. headerValue

var g_Slides = new Array();
var g_CurrentSlide;

function Slide(){
	this.Id=0; //keep 0 in order to know it's a new slide.
	this.Title="";
	this.Number=0;
	this.Time = 0; //seconds to the start.
	this.Element;
	this.Index = 0;
}

function VideoResult(){
	this.success = null,
	this.value = null
}


$(document).ready(function(){
	if (! parseInt(lectureId)){
		window.location = "lectureslist.maml";	
	}
	else{
		init();	
		makeScrollable("div.slides_horizontal", "ul.scrollable");
		UpdateMenuHeight();
	}
});


function init(){
	
	hideMessage();
	toggleHeader(headerValue);				
	toggleSlidePreview(false);
	toggleVideoLink(false);
	hideComments(g_EnableComments);	
	
	//populate g_Slides array and add items to the slide list	
	populateSlides();
	removeScripts(); //not sure of the functionality Gaurav Kr.
	addSlideListItem();
	
	//show first slide
	if(g_Slides.length > 0 ){
		g_CurrentSlide = g_Slides[0];
		showSlide(g_CurrentSlide);
	}
	
	if(flagVideo && (flagVideo.trim().length > 0) && (flagVideo.trim().toLowerCase() == "on")){
		// show video
		getVideoDetails(lectureId, function(result){
			if(result && result.success){
				completeVideoTag(result.value, lectureId);
			}
			else{
				//second argument is to indicate Error
				showMessage(result.value, true)
			}
		});
	}
}

// Show hide Header

function toggleHeader(headerValue){
	
	if ((headerValue) && (headerValue.trim().length > 0)){
		$("#header").find('h1').html(headerValue);
	}
	$("#header").find('h1').show();
}


//Slide functionality
function populateSlides (){
	// empty the array;
	g_Slides = [];
	
	$(".slidedata .slide").each(function(index,elem){
		var slide = new Slide();
		slide.Id = $(elem).attr("data-id");
		slide.Title = $(elem).attr("data-title");
		slide.Number = parseInt($(elem).attr("data-number"));
		slide.Time = parseInt($(elem).attr("data-time"));
		slide.Element = elem.innerHTML;
		slide.Index = index;
		g_Slides.push(slide);
	});
	
	if(g_Slides.length > 0){
		hideMessage();
	}
	else{
		showMessage("No slide exist for the lecture!", true);
	}

}

function addSlideListItem(){
	
	for(var i =0, slideLen = g_Slides.length; i < slideLen; i++ ){
		var slide = g_Slides[i];
		$('<li value="'+slide.Id+'" onclick = "changeSlide('+slide.Index+');" style="cursor:pointer">'+slide.Title+'</li>').appendTo($("#sidebar_menu"));
	}	
}


//Not sure about the function and the intend behind using it - Gaurav Kr.
function removeScripts(){
	var scripts = $(".slidedata .slide").find("script");
	scripts.each(function(index2,elem2){	
		$(elem2).remove();	
	});
	
}

function changeSlide(p_SlideIndex) {
	g_CurrentSlide = g_Slides[p_SlideIndex];
	if(g_CurrentSlide){
		showSlide(g_CurrentSlide);
		setTime(g_CurrentSlide.Time);
		checkControlVisbility(g_CurrentSlide.Index);
	}
}

function showSlide(p_TheSlide) {
	if (p_TheSlide)
	{
		if(p_TheSlide.Element){
			$("#slidePreview").show();
			$("#slidePreviewContent").html(p_TheSlide.Element);
		}
		else{
			$("#slidePreviewContent").html("");	
		}	
		
		$("#sidebar_menu").find('li').each( function() {
			if ($(this).attr("value") == p_TheSlide.Id){			
				$(this).attr("class", "selected");
				var position = $(this).position().top; 
				var offset = document.getElementById('slidesIndex').scrollTop;
				var height = $('#slidesIndex').height();
				var elem_offset = $(this).offset().top- $('#sidebar_menu').offset().top;
				var isVisible = (elem_offset > offset) && (elem_offset < (height+offset));
				if (!isVisible)
				$('#slidesIndex').scrollTop(elem_offset);				
			}
			else 
			$(this).attr("class", "");
		});
		
		toggleSlidePreview(true);		
		showHideNotes();
		
		//load comments if enables
		if (g_EnableComments == '1'){
			loadComments(p_TheSlide.Id, function(result){
				if(result && result.success){
					$("#commentsPreview").html(result.value);
					$("#comments_img").attr("src", "images/section_expanded.png");
					toggleComments();
					UpdateMenuHeight();
				}
				else{
					showMessage(result.value, true);
				}				
			});			
		}
	}
}


//Video functionality

function toggleVideoLink(flag){
	if(flag){
		$("#videoLinkDiv").show();
	}
	else{
		$("#videoLinkDiv").hide();
	}
}

function showVideo(){
	
	$("#sidebar").removeClass('novideo_sidebar').addClass('video_sidebar');
	$("#slidesIndex").removeClass('indexMarginTop').addClass('indexNoMarginTop'); 
	$("#vidcontrols").removeClass('vidcontrols_novideo').addClass('vidcontrols_video');	
	
	var ele = $("#videoLink");
	if(ele){
		ele.unbind();
		ele.attr("onClick","hideVideo()");
		ele.html('<img src="images/hide-video.png" style="width:12px; height:12px;" />');			
	}
	UpdateMenuHeight();
}

function hideVideo(){
	$("#sidebar").removeClass('video_sidebar').addClass('novideo_sidebar'); 
	$("#slidesIndex").removeClass('indexNoMarginTop').addClass('indexMarginTop'); 
	$("#vidcontrols").removeClass('vidcontrols_video').addClass('vidcontrols_novideo');
	
	var ele = $("#videoLink");
	if(ele){
		ele.unbind();
		ele.attr("onClick","showVideo()");
		ele.html('<img src="images/show-video.png" style="width:12px; height:12px;" />');						
	}	
	UpdateMenuHeight();
}

function setPoster(){
	/*update the poster*/
	var theVideo = document.getElementById('lecture');
	if (theVideo && g_Poster && (! g_Poster.trim().length > 0)) {
		theVideo.poster = "videotracks/"+lectureId+"/"+g_Poster;
	} 
	else {
		theVideo.poster = 'images/default_poster.png';
	}	
}

function toggleVideoLink(show){
	
	if(show){
		$("#videoLinkDiv").show();
	} 
	else {
		$("#videoLinkDiv").hide();
		$("#slidesIndex").removeClass('indexNoMarginTop').addClass('indexMarginTop'); 
	}	
}

function addVideoListeners() {	
	
	var theLecture = document.getElementById('lecture');
	if(theLecture){
		theLecture.addEventListener('timeupdate', watchTime, false);
		theLecture.addEventListener('progress',getBuffered,false);			
	}
}

function watchTime() {
	try{
		var theLecture = document.getElementById('lecture');
		var seconds =  Math.round(theLecture.currentTime);
		document.getElementById('videotime').innerText = seconds;
		
		for(var i=0, slideLen = g_Slides.length; i< slideLen;i++){
			if (g_Slides[i].Id != g_CurrentSlide.Id && g_Slides[i].Time < seconds) {
				if (i == (g_Slides.length - 1) || g_Slides[i+1].Time > seconds)
				{
					document.getElementById('debug').innerText = g_Slides[i].Time;
					g_CurrentSlide = g_Slides[i];
					if(g_CurrentSlide){
						showSlide(g_CurrentSlide);
						checkControlVisbility(i);	
					}
					break;
				}
			}
		}
	}catch(ex) {}
}

function getBuffered() {
	var theLecture = document.getElementById('lecture');
	//check if state is ready
	if(theLecture.readyState === 4){
		var soFar = parseInt(((theLecture.buffered.end(0) / theLecture.duration) * 100));
		document.getElementById("loadStatus").innerText =  soFar + '%';
		document.getElementById("thermometer").style.width =  soFar + 'px';
		if (soFar >= 100) {
			document.getElementById("loadcount").style.border = "none";
			document.getElementById("thermometer").style.visibility = "hidden";
			UpdateMenuHeight();		
		}
	}
}

function checkControlVisbility (p_SlideListIndex) {
	var nextCtrl = document.getElementById('next'),
	prevCtrl     = document.getElementById('previous');
	
	if(nextCtrl){
		if (p_SlideListIndex >= (g_Slides.length - 1)) {
			nextCtrl.style.visibility = "hidden";
		} 
		else {
			nextCtrl.style.visibility = "visible";
		}		
	}
	
	if(prevCtrl){
		if (p_SlideListIndex <= 0) {
			prevCtrl.style.visibility = "hidden";
		} 
		else {
			prevCtrl.style.visibility = "visible";
		}				
	}
}

function setTime(playTimeSeconds) {
	var theLecture = document.getElementById('lecture');
	if(theLecture){
		theLecture.currentTime = playTimeSeconds;			
	} else {
		player.seekTo(playTimeSeconds, true);
	}
}

// YouTube
function onYouTubeIframeAPIReady() {
	player = new YT.Player('videoPlayer', {
		height: '100%',
		width: '100%',
		videoId: vidData.source,
		playerVars: {
			'cc_load_policy': 1,
			'showinfo': 0,
			'rel': 0
		},
		events: {
			'onReady': onPlayerReady
		}
	});
}
function onPlayerReady(event) {
	event.target.playVideo();
	
	window.setInterval(function() {
		var seconds =  Math.round(player.getCurrentTime());
		document.getElementById('videotime').innerText = seconds;

		for(var i=0, slideLen = g_Slides.length; i< slideLen;i++){
			if (g_Slides[i].Id != g_CurrentSlide.Id && g_Slides[i].Time < seconds) {
				if (i == (g_Slides.length - 1) || g_Slides[i+1].Time > seconds)
				{
					document.getElementById('debug').innerText = g_Slides[i].Time;
					g_CurrentSlide = g_Slides[i];
					if(g_CurrentSlide){
						showSlide(g_CurrentSlide);
						checkControlVisbility(i);	
					}
					break;
				}
			}
		}
	}, 500);
	
	showVideo();
	//window.setTimeout(function() {
				var vidPlayer = document.querySelector('iframe#videoPlayer');
				if(vidPlayer !== null) {
					vidPlayer.style.height = (vidPlayer.offsetWidth / 16 * 9) + "px";
				}
	//}, 1);
}

// Video Controls 
var vidData, player;
function completeVideoTag(data, lectureId){
	vidData = data;
	if(data.source && data.type){
		if(data.type == "youtube") {
			var tag = document.createElement('script');
			tag.src = "https://www.youtube.com/iframe_api";
			var firstScriptTag = document.getElementsByTagName('script')[0];
			firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
			document.getElementById('vidcontrols').style = "display:none";
		} else {
			var source = document.createElement('source'),
			track =  document.createElement('track');
			source.src = 'videotracks/'+lectureId+'/'+data.source;
			source.type = data.type;
	
			$("#lecture")[0].appendChild(source);
			$("#lecture")[0].appendChild(track);
		
			track.src = "commands/caption/caption.maml?t_LectureID="+lectureId;
			var isChromium = window.chrome,
			winNav = window.navigator,
			vendorName = winNav.vendor,
			isOpera = winNav.userAgent.indexOf("OPR") > -1,
			isIEedge = winNav.userAgent.indexOf("Edge") > -1,
			isIOSChrome = winNav.userAgent.match("CriOS");
			  var is_safari = navigator.userAgent.toLowerCase().indexOf('safari/') > -1;

			if(isChromium !== null && isChromium !== undefined && vendorName === "Google Inc." && isOpera == false && isIEedge == false) {
				track.kind = "subtitles";

			} else if(is_safari){
				track.kind = "subtitles";

			} else {
				track.kind = "caption";

			}
			track.srclang = "en";
			track.label = "English";
			
			var flagVideo = ($("#lecture source").length > 0);

			if( flagVideo){
				setPoster();
				addVideoListeners();
				showVideo();
			}

			toggleVideoLink(flagVideo);
			toggleVideoLink(flagVideo);
		}
	}

}

function getVideoDetails(lectureId, callback){
	var obj = new VideoResult();
	$.ajax({
		url:'commands/video/videodetails.maml',
		type:'POST',
		data: {t_LectureID:lectureId},
		dataType: 'json',
		success: function(data){
			obj.success = true;
			obj.value = data;			
			if(callback){
				callback(obj);	
			}
		},
		error: function(qXHR, textStatus, errorThrown){
			obj.success = false;
			obj.value = "Error occurred while fetching video details!";
			if(callback){
				callback(obj);	
			}
		}
	});
}

function nextSlide() {
	
	if (g_CurrentSlide && g_CurrentSlide.Index < g_Slides.length){ 
		g_CurrentSlide = g_Slides[g_CurrentSlide.Index + 1];
		if(g_CurrentSlide){
			showSlide(g_CurrentSlide);
			setTime(g_CurrentSlide.Time);            
			checkControlVisbility(g_CurrentSlide.Index);	
		}
	}
}

function previousSlide() {
	if (g_CurrentSlide && g_CurrentSlide.Index > 0 ){
		g_CurrentSlide = g_Slides[g_CurrentSlide.Index - 1];
		if(g_CurrentSlide){
			showSlide(g_CurrentSlide);
			setTime(g_CurrentSlide.Time);          
			checkControlVisbility(g_CurrentSlide.Index); 
		}
	}
}

function toggleCaption() {
	if(document.getElementsByTagName('video')[0]){
		if (myVideo.textTracks[0].mode === 'disabled') {
			myVideo.textTracks[0].mode = 'showing';
			document.getElementById('caption').childNodes[0].src = "images/caption_on.png";
		} 
		else {
			myVideo.textTracks[0].mode = 'disabled';
			document.getElementById('caption').childNodes[0].src = "images/caption_off.png";
		}		
		
	}
		var vid = document.getElementById("lecture");
}


// Content Section
function toggleSlidePreview(flag){
	if(flag){
		$("#slidePreview").show();	
	}
	else{
		$("#slidePreview");	
	}	
}


//Notes 
function showHideNotes(callback){
	var slide = g_CurrentSlide;
	var hasNote = false;
	if(slide){
		var ele = document.getElementById("notes"+slide.Number);	
		if(ele){
			var notes = ele.innerHTML;
			if(notes.trim().length > 0 ){
				hasNote = true;
				$("#notesLink").show();
			}
		}
	}
	
	if(! hasNote){				
		$("#notesLink").hide();		
	}
	
	$("#notes_img").attr("src", "images/section_expanded.png");
	toggleNotes();
}

function toggleNotes(){
	var index = $("#notes_img").attr("src").indexOf("collapsed");
	
	if(index === -1){
		//Expanded state need to hide
		$("#notesPreview").html("");
		$("#notesPreview").hide();
		$("#notes_img").attr("src", "images/section_collapsed.png");
	}
	else{
		//Collapsed state need to show
		var slide = g_CurrentSlide;
		var ele = document.getElementById("notes"+slide.Number);
		if(ele){
			$("#notesPreview").html(ele.innerHTML);
		}
		else{
			$("#notesPreview").html("");	
		}
		$("#notesPreview").show();
		$("#notes_img").attr("src", "images/section_expanded.png");
	}
	UpdateMenuHeight();
}


// Comment

function hideComments(flag){
	if (!(flag == 1)){
		$("#commentsLink").hide();	
	}
}

function toggleComments(){
	var index = $("#comments_img").attr("src").indexOf("collapsed");
	
	if(index === -1){
		//Expanded state need to collapse
		$("#commentsPreview").hide();
		$("#comments_img").attr("src", "images/section_collapsed.png");
	}
	else{
		//Collapsed state need to expand	
		$("#commentsPreview").show();
		$("#comments_img").attr("src", "images/section_expanded.png");
	}
	UpdateMenuHeight();
}

function ShowAddComment() {
	$("#AddComment").fadeIn();
	$('#btnSubmit').attr('disabled',true);
}

function HideAddComment() {
	$("#AddComment").fadeOut(500);
	$("#comments").val('');
	$("#comments").css("border-Color", "");
}

function loadComments(id, callback){
	var obj = new VideoResult();
	$.ajax({
		type : 'POST',
		url : 'commands/slide/comments.maml',
		data:{t_SlideID:id},
		success : function(data){
			obj.success = true;
			obj.value = data;
			if(callback){
				callback(obj);
			}					
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			obj.success = false;
			obj.value = "Error occurred while loading comment!";
			if(callback){
				callback(obj);
			}
		}
	});
}

function AddComment(){
	var comments = $("#comments").val().trim();
	if (comments.length === 0){	
		$("#comments").css("border-Color", "#FF0000");
		return;
	}
	//addCommentRecord
	if(g_CurrentSlide){
		addCommentRecord(g_CurrentSlide.Id, userId, comments, function(result){
			if(result && result.success){
				var slideId = result.value;
				loadComments(slideId, function(result1){
					if(result1 && result1.success){
						$("#commentsPreview").html(result1.value);
						// collapse to start with
						$("#comments_img").attr("src", "images/section_expanded.png");
						UpdateMenuHeight();
						HideAddComment();
					}
					else{
						showMessage(result1.value, true);				
					}					
				});	
			}
			else{
				showMessage(result.value, true);
			}			
		});	
		
	}	
}

function addCommentRecord(slideId, userId, comment, callback){
	var obj = new VideoResult();
	$.ajax({
		url:'commands/slide/addcomment.maml',
		type:'POST',
		data: {t_slideid: slideId, t_userid:userId, t_comment: comment},
		success: function(data){
			obj.success = true;
			obj.value = slideId;
			if(callback){
				callback(obj);
			}			  
		},
		error: function(qXHR, textStatus, errorThrown){
			//callback(slideId);
			obj.success = false;
			obj.value = "Error occurred adding comment!";
			if(callback){
				callback(obj);
			}	
		}
	});
}


// UI functionality

$(window).on("resize", function () {
	UpdateMenuHeight();
});

function UpdateMenuHeight(){
	var windowSize = $(window).innerHeight();
	windowSize = 0.9*windowSize - 20; // top margin
	windowSize = windowSize - 80; // header
	windowSize = windowSize - 12; // border 
	windowSize = windowSize - 35;  //padding
	var content = $("#content").height();
	
	// we need to adjust the menu based on the max of content part or window
	if (content > windowSize){
		windowSize = content;
	}
	
	fv_menu_height = windowSize;
	
	if( $('#lecture').is(':visible') ) {
		var video_height = $("#lecture").height(); 
		var videocontrols_height = $("#vidcontrols").height();
		fv_menu_height = fv_menu_height - video_height - videocontrols_height;
	}
	
	if (fv_menu_height < 160){
		fv_menu_height = 160;
	}
	
	$("#slidesIndex").height(fv_menu_height);
}

function showMessage(msg, isError){
	$("#message").show();
	$("#message").text(msg);
}

function hideMessage(){
	$("#message").text("");
	$("#message").hide();
}

